unit hiMST_HDHints;

interface
     
uses Windows, Messages, Kol, Share, Debug, hiMTStrTbl, hiHintManager;

const
  HDM_HITTEST   = $00001206;
  HHT_ONHEADER  = $00000002;
  HHT_ONDIVIDER = $00000004;
  HHT_ONDIVOPEN = $00000008;

type
  PHDHitTestInfo = ^THDHitTestInfo;
  THDHitTestInfo = packed record
    Point: TPoint;
    Flags: Cardinal;
    Item: Integer;
  end;
  HD_HITTESTINFO = THDHITTESTINFO;

type
  THIMST_HDHints = class(TDebug)
  private
    hid: pointer;
    fHint: IHintManager;
    fHDHintsIcon: PIcon;
    sControl: PControl;
    Arr:PArray;
    Header: HWND; 
    CurItem: integer;
    InitTimer: boolean;
    InitMouseHover: boolean;
    t_MouseEvent: TTrackMouseEvent;
    HDHints: PStrList;
    FMSTControl: IMSTControl;

    procedure _Set(var Item: TData; var Val: TData);
    function _Get(var Item: TData; var Val: TData):boolean;
    function _Count:integer;
    procedure _Add(var Val: TData);
    procedure SetMSTControl(Value: IMSTControl);
    procedure SetHintManager(Value: IHintManager);
    procedure SetHDHints(const Value: string);
    procedure SetCHDHintsIcon(value:HICON);
  public
    _prop_HDHintsTitle: string;
    _prop_OnEmptyAreaHint: string;
    _prop_OnDividerHint: string;
    _prop_OnDivopenHint: string;
    _prop_HDHintsIcon: integer;

    _event_onHDMouseDown,
    _event_onHDMouseMove,
    _event_onHDMouseEnter,
    _event_onHDMouseLeave: THI_Event;

    constructor Create;
    destructor Destroy; override;
    property _prop_MSTControl: IMSTControl read FMSTControl write SetMSTControl;           
    property _prop_HintManager: IHintManager read fHint write SetHintManager;
    property _prop_HDHints: string write SetHDHints;

    procedure _work_doHDHints(var _Data: TData; Mode: integer);
    procedure _work_doHDHintsTitle(var _Data: TData; Index: word);
    procedure _work_doHDHintsIcon(var _Data: TData; Index: word);
    procedure _work_doOnEmptyAreaHint(var _Data: TData; Index: word);
    procedure _work_doOnDividerHint(var _Data: TData; Index: word);
    procedure _work_doOnDivopenHint(var _Data: TData; Index: word);
    procedure _work_doCustomHDHintsIcon(var _Data: TData; Index: word);
    procedure _work_doClearHDHints(var _Data: TData; Mode: integer);
    procedure _var_HintsText(var _Data: TData; Index:word);
    procedure _var_HintsCount(var _Data: TData; Index:word);
    procedure _var_HintsArray(var _Data: TData; Index:word);
    property _prop_CustomHDHintsIcon: HICON write SetCHDHintsIcon;
  end;

implementation

const
  cctrl = Windows.comctl32;

const
  TMINITIAL = 1;
  TMAUTOPOP = 2;

var
  defHintHD: THIHintManager; 

type
  UINT_PTR  = Cardinal;
  DWORD_PTR = Cardinal;

  TSubClassProc = function (hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM; uIdSubclass: UINT_PTR; dwRefData: DWORD_PTR): LRESULT; stdcall;

  function SetWindowSubclass   (hWnd: Windows.HWND; pfnSubclass: TSubClassProc; uIdSubclass: UINT_PTR; dwRefData: DWORD_PTR):BOOL; stdcall; external cctrl name 'SetWindowSubclass';
  function RemoveWindowSubclass(hWnd: Windows.HWND; pfnSubclass: TSubClassProc; uIdSubclass: UINT_PTR):BOOL;                       stdcall; external cctrl name 'RemoveWindowSubclass';
  function DefSubclassProc     (hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM):LRESULT;                                   stdcall; external cctrl name 'DefSubclassProc';

  function TrackMouseEvent(var EventTrack: TTrackMouseEvent): BOOL; stdcall; external user32 name 'TrackMouseEvent';

function sws_HeaderWndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM; uIdSubclass: UINT_PTR; dwRefData: DWORD_PTR): LRESULT; stdcall;
var
  MyClass: THIMST_HDHints;
  pt: TPoint;
  HDHitTestInfo: THDHitTestInfo;
  dx, dy, dc, di: TData;
  rc: TRect;
begin
  MyClass := THIMST_HDHints(dwRefData); 
  with MyClass do 
  begin
    Result := DefSubclassProc(hWnd, uMsg, wParam, lParam);
    case uMsg of
      WM_MOUSEMOVE:
      begin
        t_MouseEvent.cbSize := SizeOf(TTrackMouseEvent);
        t_MouseEvent.hwndTrack := hWnd;
        t_MouseEvent.dwFlags := TME_LEAVE; 
        TrackMouseEvent(t_MouseEvent);
        pt.X := LoWord(lParam);
        pt.Y := HiWord(lParam); 
        HDHitTestInfo.Point := pt;
        HDHitTestInfo.flags := 0;
        Sendmessage(hWnd, HDM_HITTEST, 0, DWORD_PTR(@HDHitTestInfo));
		if (HDHitTestInfo.flags = HHT_ONDIVIDER) then
          HDHitTestInfo.Item := -2		
		else if (HDHitTestInfo.flags = HHT_ONDIVOPEN) then  
          HDHitTestInfo.Item := -3
        else if HDHitTestInfo.flags <> HHT_ONHEADER then
          HDHitTestInfo.Item := -1;

        if HDHitTestInfo.Item <> CurItem then 
        begin
          CurItem := HDHitTestInfo.Item;
          if Assigned(_prop_HintManager)then
		  begin
			Case CurItem of 
              -1: _prop_HintManager.hint(hid, _prop_OnEmptyAreaHint);
			  -2: _prop_HintManager.hint(hid, _prop_OnDividerHint);
              -3: _prop_HintManager.hint(hid, _prop_OnDivopenHint);
			else
              _prop_HintManager.hint(hid, HDHints.Items[CurItem]);
            end;
            _prop_HintManager.hide(hid);
            SetTimer(hWnd, hWnd - TMINITIAL, _prop_HintManager.gettminit, nil);
          end;
        end;

        dtInteger(dx, pt.X);
        dtInteger(dy, pt.Y);
		dtInteger(di, HDHitTestInfo.Item);
		dx.ldata := @dy;
		dy.ldata := @di;

        if Assigned(_prop_HintManager)then
          if {$ifdef F_P}boolean{$endif}(_prop_HintManager.gethtreck) then
            _prop_HintManager.move(hid, pt.X, pt.Y);

        if not InitMouseHover then
        begin
          GetCursorPos(pt);
		  GetWindowRect(hWnd, rc);
          if PtInRect(rc, pt) then
            Sendmessage(hWnd, WM_MOUSEHOVER, 0, 0);
          InitMouseHover := true;
        end;
        if Assigned(_prop_HintManager) then
		begin
          if not InitTimer then
          begin
            SetTimer(hWnd, hWnd - TMINITIAL, _prop_HintManager.gettminit, nil);
            InitTimer := true;
          end;
		end;
        _hi_onEvent_(_event_onHDMouseMove, dx);
      end;
      WM_TIMER:
      begin
        if (dword(wParam) = dword(hWnd - TMINITIAL)) then
        begin
          if _prop_HDHintsIcon < 7 then
            _prop_HintManager.title(hid, _prop_HDHintsIcon, _prop_HDHintsTitle)
          else
            _prop_HintManager.title(hid, fHDHintsIcon.Handle, _prop_HDHintsTitle);
          _prop_HintManager.show(hid);
          KillTimer(hWnd, hWnd - TMINITIAL);
          if not {$ifdef F_P}boolean{$endif}(_prop_HintManager.gethtreck) then
            SetTimer(hWnd, hWnd - TMAUTOPOP, _prop_HintManager.gettmautopop, nil);
        end
        else if (dword(wParam) = dword(hWnd - TMAUTOPOP)) then
        begin
          _prop_HintManager.hint(hid, '');
          _prop_HintManager.hide(hid);
          KillTimer(hWnd, hWnd - TMAUTOPOP)
        end;
      end;
      WM_LBUTTONDOWN, WM_RBUTTONDOWN, WM_MBUTTONDOWN:
      begin
        if (wParam = 1) or (wParam = 2) then
          dtInteger(dc, wParam - 1)
        else if wParam = 16 then
          dtInteger(dc, 2)
        else
          dtInteger(dc, -1);
        pt.X := LoWord(lParam);
        pt.Y := HiWord(lParam); 
        HDHitTestInfo.Point := pt;
        HDHitTestInfo.flags := HHT_ONHEADER;
        Sendmessage(hWnd, HDM_HITTEST, 0, dword_ptr(@HDHitTestInfo));
        dtInteger(di, HDHitTestInfo.Item);
        dc.ldata := @di;
        _hi_onEvent_(_event_onHDMouseDown, dc)
      end;
	  WM_MOUSEHOVER:
        _hi_onEvent(_event_onHDMouseEnter);
      WM_MOUSELEAVE:
      begin
        if Assigned(_prop_HintManager) then
        begin
          _prop_HintManager.hint(hid, '');
          _prop_HintManager.hide(hid);
          KillTimer(hWnd, hWnd - TMINITIAL);
          KillTimer(hWnd, hWnd - TMAUTOPOP);
          InitTimer := false;
        end;
        CurItem := -4;
        InitMouseHover := false;
        _hi_onEvent(_event_onHDMouseLeave);
      end;
    end;
  end;
end;

constructor THIMST_HDHints.Create;
begin
  inherited;
  HDHints := NewStrList;
  Header := 0;  
  CurItem := -4;
  InitTimer := false;
end;

destructor THIMST_HDHints.Destroy;
begin
  HDHints.free;
  fHDHintsIcon.free;
  if hid <> nil then fHint.free(hid);
  if Header <> 0 then
    RemoveWindowSubclass(Header, @sws_HeaderWndProc, 1);
  inherited;
end;

procedure THIMST_HDHints.SetMSTControl;
begin
  if Value = nil then exit;
  FMSTControl := Value;
  sControl := Value.ctrlpoint;
  if sControl.LVStyle <> lvsDetail then exit;

  Header := sControl.Perform(LVM_GETHEADER, 0, 0);
  SetWindowSubclass(Header, @sws_HeaderWndProc, 1, dword_ptr(THIMST_HDHints(Self)));
end;

procedure THIMST_HDHints.SetHintManager;
begin
  if not Assigned(sControl) then exit;

  if Value = nil then
    if HDHints.Text = '' then
      exit
    else
      Value := defHintHD.getInterfaceHint;

  hid := Value.init(sControl.GetWindowHandle);
  Value.hint(hid, '');
  fHint := Value;
end;

procedure THIMST_HDHints.SetHDHints;
begin
  HDHints.SetText(Value, false);
end;

procedure THIMST_HDHints.SetCHDHintsIcon;
begin
  fHDHintsIcon := NewIcon;
  fHDHintsIcon.Handle := Value;
end;

procedure THIMST_HDHints._work_doHDHints;
begin
  SetHDHints(ToString(_Data));
end;

procedure THIMST_HDHints._work_doOnEmptyAreaHint;
begin
  _prop_OnEmptyAreaHint := ToString(_Data);
end;

procedure THIMST_HDHints._work_doOnDividerHint;
begin
  _prop_OnDividerHint := ToString(_Data);
end;

procedure THIMST_HDHints._work_doOnDivopenHint;
begin
  _prop_OnDivopenHint := ToString(_Data);
end;

procedure THIMST_HDHints._work_doHDHintsTitle;
begin
  _prop_HDHintsTitle := ToString(_Data);
end;

procedure THIMST_HDHints._work_doHDHintsIcon;
begin
  _prop_HDHintsIcon := Max(0, Min(7, ToInteger(_Data)));
end;

procedure THIMST_HDHints._work_doCustomHDHintsIcon;
begin
  if not _IsIcon(_Data) then exit;
  if fHDHintsIcon = nil then
    fHDHintsIcon := NewIcon
  else
    fHDHintsIcon.Clear;  
  fHDHintsIcon{$ifndef F_P}^{$endif} := ToIcon(_Data){$ifndef F_P}^{$endif};
end;

procedure THIMST_HDHints._work_doClearHDHints;
begin
  HDHints.Clear;
end;

procedure THIMST_HDHints._var_HintsText;
begin
   dtString(_Data, HDHints.Text);
end;

procedure THIMST_HDHints._var_HintsCount;
begin
  dtInteger(_Data, HDHints.Count);
end;

procedure THIMST_HDHints._Set;
var
  ind:integer;
begin
  ind := ToIntIndex(Item);
  if (ind >= 0) and (ind < HDHints.Count) then
    HDHints.Items[ind] := ToString(Val);
end;

procedure THIMST_HDHints._Add;
begin
  HDHints.Add(ToString(val));
end;

function THIMST_HDHints._Get;
var
  ind:integer;
begin
  ind := ToIntIndex(Item);
  if (ind >= 0) and (ind < HDHints.Count) then
  begin
    Result := true;
    dtString(Val, HDHints.Items[ind]);
  end
  else
    Result := false;
end;

function THIMST_HDHints._Count;
begin
   Result := HDHints.Count;
end;

procedure THIMST_HDHints._var_HintsArray;
begin
  if Arr = nil then Arr := CreateArray(_Set, _Get, _Count, _Add);
  dtArray(_Data,Arr);
end;

initialization
  defHintHD := THIHintManager.Create;
  defHintHD.InitByDefault;
end.